=== debian/changelog ===
actor-framework (0.16.3-0.3) unstable; urgency=high

  * Non-maintainer upload
  * Replace pandocfilters build-dependency with Python3 variant
    (Closes: #942907)

 -- Hilko Bengen <bengen@debian.org>  Tue, 11 Feb 2020 14:41:43 +0100

actor-framework (0.16.3-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Add Breaks/Replaces to libcaf-doc (Closes: #923547)

 -- Hilko Bengen <bengen@debian.org>  Sat, 02 Mar 2019 12:35:04 +0100

actor-framework (0.16.3-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version 0.16.3
  * Update SONAME, remove pkg-config files
  * Cleanup build system, add -openssl, -doc packages
  * Bump Debhelper compat level
  * Bump Standards-Version

 -- Hilko Bengen <bengen@debian.org>  Wed, 06 Feb 2019 00:40:31 +0100
