=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_CXXFLAGS_MAINT_APPEND = -std=c++11 -pthread

override_dh_auto_configure:
	dh_auto_configure -- -DCAF_BUILD_TEX_MANUAL=1

override_dh_auto_build:
	dh_auto_build -- all doxygen doc

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libcaf-doc
	mv debian/tmp/usr/share/caf/examples \
	   debian/tmp/usr/share/doc/libcaf-doc
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@ --buildsystem=cmake
